/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../include/extra/cstring.h"
#include "__internal/include.h"

size_t libcdsb_strlen(const char* s) {
    static const size_t m = (sizeof(size_t) == 8) ? 0x8080808080808080UL : 0x80808080UL;
    static const size_t d = (sizeof(size_t) == 8) ? 0x0101010101010101UL : 0x01010101UL;

    const u8_t* p;
    const size_t* w;

    p = (void*)s;

    while((uintptr_t)p%sizeof(size_t)) {
        if (!*p) return (void*)p - (void*)s;
        ++p;
    }

    w = (void*)p;

    while (!((*w-d)&(~*w&m))) { ++w; }

    p = (void*)w;

    while (*p) { ++p; }

    return (void*)p - (void*)s;
}


size_t libcdsb_strasciilen(const char* s) {
    static const size_t m = (sizeof(size_t) == 8) ? 0x8080808080808080UL : 0x80808080UL;
    static const size_t d = (sizeof(size_t) == 8) ? 0x0101010101010101UL : 0x01010101UL;

    const u8_t* p;
    const size_t* w;

    p = (void*)s;

    while((uintptr_t)p%sizeof(size_t)) {
        if (!*p || (*p&0x80))
            return (void*)p - (void*)s;
        ++p;
    }

    w = (void*)p;

    while (!((*w&m)||((*w-d)&m))) { ++w; }

    p = (void*)w;

    while (*p && !(*p&0x80)) { ++p; }

    return (void*)p - (void*)s;
}
