/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

_Bool libcdsb_map_find_pointer(val_t* x, map_t* s, const   void* k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_cstring(val_t* x, map_t* s, const   char* k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_string (val_t* x, map_t* s, const  str_t* k, _Bool cut) { return libcdsb_map_find(x, s,  k, vtypeof( k), cut); }
_Bool libcdsb_map_find_array  (val_t* x, map_t* s, const  arr_t* k, _Bool cut) { return libcdsb_map_find(x, s,  k, vtypeof( k), cut); }
_Bool libcdsb_map_find_list   (val_t* x, map_t* s, const list_t* k, _Bool cut) { return libcdsb_map_find(x, s,  k, vtypeof( k), cut); }
_Bool libcdsb_map_find_map    (val_t* x, map_t* s, const  map_t* k, _Bool cut) { return libcdsb_map_find(x, s,  k, vtypeof( k), cut); }
_Bool libcdsb_map_find_vset   (val_t* x, map_t* s, const  set_t* k, _Bool cut) { return libcdsb_map_find(x, s,  k, vtypeof( k), cut); }
_Bool libcdsb_map_find_boolean(val_t* x, map_t* s,         _Bool k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_int8   (val_t* x, map_t* s,          s8_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_int16  (val_t* x, map_t* s,         s16_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_int32  (val_t* x, map_t* s,         s32_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_int64  (val_t* x, map_t* s,         s64_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_uint8  (val_t* x, map_t* s,          u8_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_uint16 (val_t* x, map_t* s,         u16_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_uint32 (val_t* x, map_t* s,         u32_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_uint64 (val_t* x, map_t* s,         u64_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_float  (val_t* x, map_t* s,          fl_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_double (val_t* x, map_t* s,         dbl_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }
_Bool libcdsb_map_find_ldouble(val_t* x, map_t* s,        ldbl_t k, _Bool cut) { return libcdsb_map_find(x, s, &k, vtypeof(&k), cut); }

_Bool libcdsb_map_update_pointer_pointer(map_t* x, const void* k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_cstring(map_t* x, const void* k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_string (map_t* x, const void* k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_pointer_array  (map_t* x, const void* k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_pointer_list   (map_t* x, const void* k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_pointer_map    (map_t* x, const void* k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_pointer_vset   (map_t* x, const void* k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_pointer_boolean(map_t* x, const void* k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_int8   (map_t* x, const void* k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_int16  (map_t* x, const void* k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_int32  (map_t* x, const void* k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_int64  (map_t* x, const void* k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_uint8  (map_t* x, const void* k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_uint16 (map_t* x, const void* k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_uint32 (map_t* x, const void* k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_uint64 (map_t* x, const void* k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_float  (map_t* x, const void* k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_double (map_t* x, const void* k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_pointer_ldouble(map_t* x, const void* k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_cstring_pointer(map_t* x, const char* k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_cstring(map_t* x, const char* k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_string (map_t* x, const char* k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_cstring_array  (map_t* x, const char* k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_cstring_list   (map_t* x, const char* k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_cstring_map    (map_t* x, const char* k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_cstring_vset   (map_t* x, const char* k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_cstring_boolean(map_t* x, const char* k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_int8   (map_t* x, const char* k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_int16  (map_t* x, const char* k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_int32  (map_t* x, const char* k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_int64  (map_t* x, const char* k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_uint8  (map_t* x, const char* k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_uint16 (map_t* x, const char* k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_uint32 (map_t* x, const char* k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_uint64 (map_t* x, const char* k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_float  (map_t* x, const char* k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_double (map_t* x, const char* k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_cstring_ldouble(map_t* x, const char* k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_string_pointer(map_t* x, const str_t* k,   const void* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_cstring(map_t* x, const str_t* k,   const char* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_string (map_t* x, const str_t* k,  const str_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_string_array  (map_t* x, const str_t* k,  const arr_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_string_list   (map_t* x, const str_t* k, const list_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_string_map    (map_t* x, const str_t* k,  const map_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_string_vset   (map_t* x, const str_t* k,  const set_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_string_boolean(map_t* x, const str_t* k,         _Bool v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_int8   (map_t* x, const str_t* k,          s8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_int16  (map_t* x, const str_t* k,         s16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_int32  (map_t* x, const str_t* k,         s32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_int64  (map_t* x, const str_t* k,         s64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_uint8  (map_t* x, const str_t* k,          u8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_uint16 (map_t* x, const str_t* k,         u16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_uint32 (map_t* x, const str_t* k,         u32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_uint64 (map_t* x, const str_t* k,         u64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_float  (map_t* x, const str_t* k,          fl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_double (map_t* x, const str_t* k,         dbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_string_ldouble(map_t* x, const str_t* k,        ldbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_array_pointer(map_t* x, const arr_t* k,   const void* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_cstring(map_t* x, const arr_t* k,   const char* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_string (map_t* x, const arr_t* k,  const str_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_array_array  (map_t* x, const arr_t* k,  const arr_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_array_list   (map_t* x, const arr_t* k, const list_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_array_map    (map_t* x, const arr_t* k,  const map_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_array_vset   (map_t* x, const arr_t* k,  const set_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_array_boolean(map_t* x, const arr_t* k,         _Bool v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_int8   (map_t* x, const arr_t* k,          s8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_int16  (map_t* x, const arr_t* k,         s16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_int32  (map_t* x, const arr_t* k,         s32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_int64  (map_t* x, const arr_t* k,         s64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_uint8  (map_t* x, const arr_t* k,          u8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_uint16 (map_t* x, const arr_t* k,         u16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_uint32 (map_t* x, const arr_t* k,         u32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_uint64 (map_t* x, const arr_t* k,         u64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_float  (map_t* x, const arr_t* k,          fl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_double (map_t* x, const arr_t* k,         dbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_array_ldouble(map_t* x, const arr_t* k,        ldbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_list_pointer(map_t* x, const list_t* k,   const void* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_cstring(map_t* x, const list_t* k,   const char* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_string (map_t* x, const list_t* k,  const str_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_list_array  (map_t* x, const list_t* k,  const arr_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_list_list   (map_t* x, const list_t* k, const list_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_list_map    (map_t* x, const list_t* k,  const map_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_list_vset   (map_t* x, const list_t* k,  const set_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_list_boolean(map_t* x, const list_t* k,         _Bool v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_int8   (map_t* x, const list_t* k,          s8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_int16  (map_t* x, const list_t* k,         s16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_int32  (map_t* x, const list_t* k,         s32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_int64  (map_t* x, const list_t* k,         s64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_uint8  (map_t* x, const list_t* k,          u8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_uint16 (map_t* x, const list_t* k,         u16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_uint32 (map_t* x, const list_t* k,         u32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_uint64 (map_t* x, const list_t* k,         u64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_float  (map_t* x, const list_t* k,          fl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_double (map_t* x, const list_t* k,         dbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_list_ldouble(map_t* x, const list_t* k,        ldbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_map_pointer(map_t* x, const map_t* k,   const void* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_cstring(map_t* x, const map_t* k,   const char* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_string (map_t* x, const map_t* k,  const str_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_map_array  (map_t* x, const map_t* k,  const arr_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_map_list   (map_t* x, const map_t* k, const list_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_map_map    (map_t* x, const map_t* k,  const map_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_map_vset   (map_t* x, const map_t* k,  const set_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_map_boolean(map_t* x, const map_t* k,         _Bool v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_int8   (map_t* x, const map_t* k,          s8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_int16  (map_t* x, const map_t* k,         s16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_int32  (map_t* x, const map_t* k,         s32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_int64  (map_t* x, const map_t* k,         s64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_uint8  (map_t* x, const map_t* k,          u8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_uint16 (map_t* x, const map_t* k,         u16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_uint32 (map_t* x, const map_t* k,         u32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_uint64 (map_t* x, const map_t* k,         u64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_float  (map_t* x, const map_t* k,          fl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_double (map_t* x, const map_t* k,         dbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_map_ldouble(map_t* x, const map_t* k,        ldbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_vset_pointer(map_t* x, const set_t* k,   const void* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_cstring(map_t* x, const set_t* k,   const char* v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_string (map_t* x, const set_t* k,  const str_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_vset_array  (map_t* x, const set_t* k,  const arr_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_vset_list   (map_t* x, const set_t* k, const list_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_vset_map    (map_t* x, const set_t* k,  const map_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_vset_vset   (map_t* x, const set_t* k,  const set_t* v) { return libcdsb_map_update(x, k, vtypeof(k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_vset_boolean(map_t* x, const set_t* k,         _Bool v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_int8   (map_t* x, const set_t* k,          s8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_int16  (map_t* x, const set_t* k,         s16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_int32  (map_t* x, const set_t* k,         s32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_int64  (map_t* x, const set_t* k,         s64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_uint8  (map_t* x, const set_t* k,          u8_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_uint16 (map_t* x, const set_t* k,         u16_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_uint32 (map_t* x, const set_t* k,         u32_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_uint64 (map_t* x, const set_t* k,         u64_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_float  (map_t* x, const set_t* k,          fl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_double (map_t* x, const set_t* k,         dbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_vset_ldouble(map_t* x, const set_t* k,        ldbl_t v) { return libcdsb_map_update(x, k, vtypeof(k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_boolean_pointer(map_t* x, const _Bool k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_cstring(map_t* x, const _Bool k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_string (map_t* x, const _Bool k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_boolean_array  (map_t* x, const _Bool k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_boolean_list   (map_t* x, const _Bool k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_boolean_map    (map_t* x, const _Bool k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_boolean_vset   (map_t* x, const _Bool k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_boolean_boolean(map_t* x, const _Bool k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_int8   (map_t* x, const _Bool k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_int16  (map_t* x, const _Bool k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_int32  (map_t* x, const _Bool k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_int64  (map_t* x, const _Bool k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_uint8  (map_t* x, const _Bool k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_uint16 (map_t* x, const _Bool k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_uint32 (map_t* x, const _Bool k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_uint64 (map_t* x, const _Bool k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_float  (map_t* x, const _Bool k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_double (map_t* x, const _Bool k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_boolean_ldouble(map_t* x, const _Bool k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_int8_pointer(map_t* x, const s8_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_cstring(map_t* x, const s8_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_string (map_t* x, const s8_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int8_array  (map_t* x, const s8_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int8_list   (map_t* x, const s8_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int8_map    (map_t* x, const s8_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int8_vset   (map_t* x, const s8_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int8_boolean(map_t* x, const s8_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_int8   (map_t* x, const s8_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_int16  (map_t* x, const s8_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_int32  (map_t* x, const s8_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_int64  (map_t* x, const s8_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_uint8  (map_t* x, const s8_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_uint16 (map_t* x, const s8_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_uint32 (map_t* x, const s8_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_uint64 (map_t* x, const s8_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_float  (map_t* x, const s8_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_double (map_t* x, const s8_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int8_ldouble(map_t* x, const s8_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_int16_pointer(map_t* x, const s16_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_cstring(map_t* x, const s16_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_string (map_t* x, const s16_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int16_array  (map_t* x, const s16_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int16_list   (map_t* x, const s16_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int16_map    (map_t* x, const s16_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int16_vset   (map_t* x, const s16_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int16_boolean(map_t* x, const s16_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_int8   (map_t* x, const s16_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_int16  (map_t* x, const s16_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_int32  (map_t* x, const s16_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_int64  (map_t* x, const s16_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_uint8  (map_t* x, const s16_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_uint16 (map_t* x, const s16_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_uint32 (map_t* x, const s16_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_uint64 (map_t* x, const s16_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_float  (map_t* x, const s16_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_double (map_t* x, const s16_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int16_ldouble(map_t* x, const s16_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_int32_pointer(map_t* x, const s32_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_cstring(map_t* x, const s32_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_string (map_t* x, const s32_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int32_array  (map_t* x, const s32_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int32_list   (map_t* x, const s32_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int32_map    (map_t* x, const s32_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int32_vset   (map_t* x, const s32_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int32_boolean(map_t* x, const s32_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_int8   (map_t* x, const s32_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_int16  (map_t* x, const s32_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_int32  (map_t* x, const s32_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_int64  (map_t* x, const s32_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_uint8  (map_t* x, const s32_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_uint16 (map_t* x, const s32_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_uint32 (map_t* x, const s32_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_uint64 (map_t* x, const s32_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_float  (map_t* x, const s32_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_double (map_t* x, const s32_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int32_ldouble(map_t* x, const s32_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_int64_pointer(map_t* x, const s64_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_cstring(map_t* x, const s64_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_string (map_t* x, const s64_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int64_array  (map_t* x, const s64_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int64_list   (map_t* x, const s64_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int64_map    (map_t* x, const s64_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int64_vset   (map_t* x, const s64_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_int64_boolean(map_t* x, const s64_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_int8   (map_t* x, const s64_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_int16  (map_t* x, const s64_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_int32  (map_t* x, const s64_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_int64  (map_t* x, const s64_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_uint8  (map_t* x, const s64_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_uint16 (map_t* x, const s64_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_uint32 (map_t* x, const s64_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_uint64 (map_t* x, const s64_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_float  (map_t* x, const s64_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_double (map_t* x, const s64_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_int64_ldouble(map_t* x, const s64_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_uint8_pointer(map_t* x, const u8_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_cstring(map_t* x, const u8_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_string (map_t* x, const u8_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint8_array  (map_t* x, const u8_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint8_list   (map_t* x, const u8_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint8_map    (map_t* x, const u8_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint8_vset   (map_t* x, const u8_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint8_boolean(map_t* x, const u8_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_int8   (map_t* x, const u8_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_int16  (map_t* x, const u8_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_int32  (map_t* x, const u8_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_int64  (map_t* x, const u8_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_uint8  (map_t* x, const u8_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_uint16 (map_t* x, const u8_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_uint32 (map_t* x, const u8_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_uint64 (map_t* x, const u8_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_float  (map_t* x, const u8_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_double (map_t* x, const u8_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint8_ldouble(map_t* x, const u8_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_uint16_pointer(map_t* x, const u16_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_cstring(map_t* x, const u16_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_string (map_t* x, const u16_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint16_array  (map_t* x, const u16_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint16_list   (map_t* x, const u16_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint16_map    (map_t* x, const u16_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint16_vset   (map_t* x, const u16_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint16_boolean(map_t* x, const u16_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_int8   (map_t* x, const u16_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_int16  (map_t* x, const u16_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_int32  (map_t* x, const u16_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_int64  (map_t* x, const u16_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_uint8  (map_t* x, const u16_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_uint16 (map_t* x, const u16_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_uint32 (map_t* x, const u16_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_uint64 (map_t* x, const u16_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_float  (map_t* x, const u16_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_double (map_t* x, const u16_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint16_ldouble(map_t* x, const u16_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_uint32_pointer(map_t* x, const u32_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_cstring(map_t* x, const u32_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_string (map_t* x, const u32_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint32_array  (map_t* x, const u32_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint32_list   (map_t* x, const u32_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint32_map    (map_t* x, const u32_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint32_vset   (map_t* x, const u32_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint32_boolean(map_t* x, const u32_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_int8   (map_t* x, const u32_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_int16  (map_t* x, const u32_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_int32  (map_t* x, const u32_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_int64  (map_t* x, const u32_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_uint8  (map_t* x, const u32_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_uint16 (map_t* x, const u32_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_uint32 (map_t* x, const u32_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_uint64 (map_t* x, const u32_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_float  (map_t* x, const u32_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_double (map_t* x, const u32_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint32_ldouble(map_t* x, const u32_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_uint64_pointer(map_t* x, const u64_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_cstring(map_t* x, const u64_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_string (map_t* x, const u64_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint64_array  (map_t* x, const u64_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint64_list   (map_t* x, const u64_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint64_map    (map_t* x, const u64_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint64_vset   (map_t* x, const u64_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_uint64_boolean(map_t* x, const u64_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_int8   (map_t* x, const u64_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_int16  (map_t* x, const u64_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_int32  (map_t* x, const u64_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_int64  (map_t* x, const u64_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_uint8  (map_t* x, const u64_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_uint16 (map_t* x, const u64_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_uint32 (map_t* x, const u64_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_uint64 (map_t* x, const u64_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_float  (map_t* x, const u64_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_double (map_t* x, const u64_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_uint64_ldouble(map_t* x, const u64_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_float_pointer(map_t* x, const fl_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_cstring(map_t* x, const fl_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_string (map_t* x, const fl_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_float_array  (map_t* x, const fl_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_float_list   (map_t* x, const fl_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_float_map    (map_t* x, const fl_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_float_vset   (map_t* x, const fl_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_float_boolean(map_t* x, const fl_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_int8   (map_t* x, const fl_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_int16  (map_t* x, const fl_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_int32  (map_t* x, const fl_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_int64  (map_t* x, const fl_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_uint8  (map_t* x, const fl_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_uint16 (map_t* x, const fl_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_uint32 (map_t* x, const fl_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_uint64 (map_t* x, const fl_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_float  (map_t* x, const fl_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_double (map_t* x, const fl_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_float_ldouble(map_t* x, const fl_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_double_pointer(map_t* x, const dbl_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_cstring(map_t* x, const dbl_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_string (map_t* x, const dbl_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_double_array  (map_t* x, const dbl_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_double_list   (map_t* x, const dbl_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_double_map    (map_t* x, const dbl_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_double_vset   (map_t* x, const dbl_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_double_boolean(map_t* x, const dbl_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_int8   (map_t* x, const dbl_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_int16  (map_t* x, const dbl_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_int32  (map_t* x, const dbl_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_int64  (map_t* x, const dbl_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_uint8  (map_t* x, const dbl_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_uint16 (map_t* x, const dbl_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_uint32 (map_t* x, const dbl_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_uint64 (map_t* x, const dbl_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_float  (map_t* x, const dbl_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_double (map_t* x, const dbl_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_double_ldouble(map_t* x, const dbl_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }

_Bool libcdsb_map_update_ldouble_pointer(map_t* x, const ldbl_t k,   const void* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_cstring(map_t* x, const ldbl_t k,   const char* v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_string (map_t* x, const ldbl_t k,  const str_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_ldouble_array  (map_t* x, const ldbl_t k,  const arr_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_ldouble_list   (map_t* x, const ldbl_t k, const list_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_ldouble_map    (map_t* x, const ldbl_t k,  const map_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_ldouble_vset   (map_t* x, const ldbl_t k,  const set_t* v) { return libcdsb_map_update(x, &k, vtypeof(&k),  v, vtypeof( v)); }
_Bool libcdsb_map_update_ldouble_boolean(map_t* x, const ldbl_t k,         _Bool v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_int8   (map_t* x, const ldbl_t k,          s8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_int16  (map_t* x, const ldbl_t k,         s16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_int32  (map_t* x, const ldbl_t k,         s32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_int64  (map_t* x, const ldbl_t k,         s64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_uint8  (map_t* x, const ldbl_t k,          u8_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_uint16 (map_t* x, const ldbl_t k,         u16_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_uint32 (map_t* x, const ldbl_t k,         u32_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_uint64 (map_t* x, const ldbl_t k,         u64_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_float  (map_t* x, const ldbl_t k,          fl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_double (map_t* x, const ldbl_t k,         dbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
_Bool libcdsb_map_update_ldouble_ldouble(map_t* x, const ldbl_t k,        ldbl_t v) { return libcdsb_map_update(x, &k, vtypeof(&k), &v, vtypeof(&v)); }
