/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "../../include/extra/set.h"
#include "../__internal/include.h"

_Bool libcdsb_vset_touch_pointer(set_t* x,   const void* k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_cstring(set_t* x,   const char* k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_string (set_t* x,  const str_t* k, _Bool f) { return libcdsb_vset_find(0, x,  k, vtypeof( k), f); }
_Bool libcdsb_vset_touch_array  (set_t* x,  const arr_t* k, _Bool f) { return libcdsb_vset_find(0, x,  k, vtypeof( k), f); }
_Bool libcdsb_vset_touch_list   (set_t* x, const list_t* k, _Bool f) { return libcdsb_vset_find(0, x,  k, vtypeof( k), f); }
_Bool libcdsb_vset_touch_map    (set_t* x,  const map_t* k, _Bool f) { return libcdsb_vset_find(0, x,  k, vtypeof( k), f); }
_Bool libcdsb_vset_touch_vset   (set_t* x,  const set_t* k, _Bool f) { return libcdsb_vset_find(0, x,  k, vtypeof( k), f); }
_Bool libcdsb_vset_touch_boolean(set_t* x,         _Bool k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_int8   (set_t* x,          s8_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_int16  (set_t* x,         s16_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_int32  (set_t* x,         s32_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_int64  (set_t* x,         s64_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_uint8  (set_t* x,          u8_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_uint16 (set_t* x,         u16_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_uint32 (set_t* x,         u32_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_uint64 (set_t* x,         u64_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_float  (set_t* x,          fl_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_double (set_t* x,         dbl_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }
_Bool libcdsb_vset_touch_ldouble(set_t* x,        ldbl_t k, _Bool f) { return libcdsb_vset_find(0, x, &k, vtypeof(&k), f); }

_Bool libcdsb_vset_push_pointer(set_t* x,   const void* v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_cstring(set_t* x,   const char* v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_string (set_t* x,  const str_t* v) { return libcdsb_vset_insert(x,  v, vtypeof( v)); }
_Bool libcdsb_vset_push_array  (set_t* x,  const arr_t* v) { return libcdsb_vset_insert(x,  v, vtypeof( v)); }
_Bool libcdsb_vset_push_list   (set_t* x, const list_t* v) { return libcdsb_vset_insert(x,  v, vtypeof( v)); }
_Bool libcdsb_vset_push_map    (set_t* x,  const map_t* v) { return libcdsb_vset_insert(x,  v, vtypeof( v)); }
_Bool libcdsb_vset_push_vset   (set_t* x,  const set_t* v) { return libcdsb_vset_insert(x,  v, vtypeof( v)); }
_Bool libcdsb_vset_push_boolean(set_t* x,         _Bool v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_int8   (set_t* x,          s8_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_int16  (set_t* x,         s16_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_int32  (set_t* x,         s32_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_int64  (set_t* x,         s64_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_uint8  (set_t* x,          u8_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_uint16 (set_t* x,         u16_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_uint32 (set_t* x,         u32_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_uint64 (set_t* x,         u64_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_float  (set_t* x,          fl_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_double (set_t* x,         dbl_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
_Bool libcdsb_vset_push_ldouble(set_t* x,        ldbl_t v) { return libcdsb_vset_insert(x, &v, vtypeof(&v)); }
